unit unitDM;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, sqldb, odbcconn, FileUtil, Dialogs, ExtDlgs, LR_DBSet, LazFileUtils, LazUTF8;

type

  { TDM }

  TDM = class(TDataModule)
    DatasourceDyn2: TDataSource;
    DatasourceDyn3: TDataSource;
    DatasourcePosition: TDataSource;
    DatasourceSystem: TDataSource;
    DatasourceDyn1: TDataSource;
    ODBCConnection: TODBCConnection;
    SQLQueryDyn2: TSQLQuery;
    SQLQueryDyn3: TSQLQuery;
    SQLQueryPosition: TSQLQuery;
    SQLQuerySystem: TSQLQuery;
    SQLQueryDyn1: TSQLQuery;
    SQLTransaction: TSQLTransaction;
    procedure SQLQueryPositionAfterOpen(DataSet: TDataSet);
  private
    { private declarations }
    procedure Text_nach_DB_umwandeln(Sender: TField; const aText: string);
    procedure Text_von_DB_umwandeln(Sender: TField; var aText: string; DisplayText: BOOLEAN);

  public
    { public declarations }
    function SQLQueryDyn1_Neu_Zuweisen(SQLString : String) : Int64;
    function SQLQueryDyn2_Neu_Zuweisen(SQLString : String) : Int64;
    function SQLQueryDyn3_Neu_Zuweisen(SQLString : String) : Int64;
    function SQLQueryAnbinden() : boolean;

    function Text_von_Control_umwandeln(aText: string) : string;
    function Text_nach_Control_umwandeln(aText: string) : string;
  end;

var
  DM: TDM;

  // Rückgabewert Anzahl der Datensätze
  SQLDyn1_RecordCount : Int64;
  SQLDyn2_RecordCount : Int64;
  SQLDyn3_RecordCount : Int64;

  TextUmwandelnOption : String; {''=keine; 1= Encode/Decode; 2=}


implementation
uses unitfrmHauptform;

{$R *.lfm}

procedure TDM.SQLQueryPositionAfterOpen(DataSet: TDataSet);
var
  i : Integer;
begin
     if TextUmwandelnOption <> '' then
        begin
             for i:=0 to DataSet.Fields.Count-1 do
                 begin
                      if (DataSet.Fields[i].DataType=ftString) or (DataSet.Fields[i].DataType=ftMemo) or (DataSet.Fields[i].DataType=ftWideMemo) or (DataSet.Fields[i].DataType=ftFmtMemo) or (DataSet.Fields[i].DataType=ftWideString) then
                         begin
                              DataSet.Fields[i].OnGetText:=@Text_von_DB_umwandeln;
                              DataSet.Fields[i].OnSetText:=@Text_nach_DB_umwandeln;
                         end;
                 end;
        end;
end;

function TDM.SQLQueryDyn1_Neu_Zuweisen(SQLString : String) : Int64;
var
   RecCount : Int64;
begin
  SQLDyn1_RecordCount := 0;
  SQLQueryDyn1.Filter:='';
  SQLQueryDyn1.Close;
  SQLQueryDyn1.Active:=false;
  SQLQueryDyn1.SQL.Clear;

  try
     SQLQueryDyn1.SQL.Text := SQLString;
     DatasourceDyn1.DataSet := SQLQueryDyn1;
     SQLQueryDyn1.Open;
     SQLQueryDyn1.Active:=true;
     SQLQueryDyn1.Last;
     RecCount := SQLQueryDyn1.RecordCount;
     SQLQueryDyn1.First;
     SQLQueryDyn1_Neu_Zuweisen := RecCount;
  except
        SQLQueryDyn1.SQL.Text := SQLString;
        DatasourceDyn1.DataSet := SQLQueryDyn1;
        SQLQueryDyn1.Open;
        SQLQueryDyn1.Active:=true;
        SQLQueryDyn1.Last;
        RecCount := SQLQueryDyn1.RecordCount;
        SQLQueryDyn1.First;
        SQLQueryDyn1_Neu_Zuweisen := RecCount;
  end;
end;

function TDM.SQLQueryDyn2_Neu_Zuweisen(SQLString : String) : Int64;
var
   RecCount : Int64;
begin
  SQLDyn2_RecordCount := 0;
  SQLQueryDyn2.Filter:='';
  SQLQueryDyn2.Close;
  SQLQueryDyn2.Active:=false;
  SQLQueryDyn2.SQL.Clear;

  try
     SQLQueryDyn2.SQL.Text := SQLString;
     DatasourceDyn2.DataSet := SQLQueryDyn2;
     SQLQueryDyn2.Open;
     SQLQueryDyn2.Active:=true;
     SQLQueryDyn2.Last;
     RecCount := SQLQueryDyn2.RecordCount;
     SQLQueryDyn2.First;
     SQLQueryDyn2_Neu_Zuweisen := RecCount;
  except
        SQLQueryDyn2.SQL.Text := SQLString;
        DatasourceDyn2.DataSet := SQLQueryDyn2;
        SQLQueryDyn2.Open;
        SQLQueryDyn2.Active:=true;
        SQLQueryDyn2.Last;
        RecCount := SQLQueryDyn2.RecordCount;
        SQLQueryDyn2.First;
        SQLQueryDyn2_Neu_Zuweisen := RecCount;
  end;
end;

function TDM.SQLQueryDyn3_Neu_Zuweisen(SQLString : String) : Int64;
var
   RecCount : Int64;
begin
  SQLDyn3_RecordCount := 0;
  SQLQueryDyn3.Filter:='';
  SQLQueryDyn3.Close;
  SQLQueryDyn3.Active:=false;
  SQLQueryDyn3.SQL.Clear;

  try
     SQLQueryDyn3.SQL.Text := SQLString;
     DatasourceDyn3.DataSet := SQLQueryDyn3;
     SQLQueryDyn3.Open;
     SQLQueryDyn3.Active:=true;
     SQLQueryDyn3.Last;
     RecCount := SQLQueryDyn3.RecordCount;
     SQLQueryDyn3.First;
     SQLQueryDyn3_Neu_Zuweisen := RecCount;
  except
        SQLQueryDyn3.SQL.Text := SQLString;
        DatasourceDyn3.DataSet := SQLQueryDyn3;
        SQLQueryDyn3.Open;
        SQLQueryDyn3.Active:=true;
        SQLQueryDyn3.Last;
        RecCount := SQLQueryDyn3.RecordCount;
        SQLQueryDyn3.First;
        SQLQueryDyn3_Neu_Zuweisen := RecCount;
  end;
end;

function TDM.SQLQueryAnbinden: boolean;
var
   basicConnectSQL : TObject;

begin
     for i := 0 to DM.ComponentCount - 1 do
         begin
              basicConnectSQL := DM.Components[i];
              if basicConnectSQL is TSQLQuery then
                 begin
                      (basicConnectSQL As TSQLQuery).DataBase := DM.ODBCConnection;
                      (basicConnectSQL As TSQLQuery).UsePrimaryKeyAsKey := False;
                      (basicConnectSQL As TSQLQuery).UpdateMode:= upWhereAll;
                      (basicConnectSQL As TSQLQuery).Filtered:=True;
                      (basicConnectSQL As TSQLQuery).MaxIndexesCount:=100;
                 end;
              SQLQueryAnbinden := true;
         end;
end;

procedure TDM.Text_nach_DB_umwandeln(Sender: TField; const aText: string);
begin
  if aText <> '' then
     begin
          if TextUmwandelnOption = '1' then
             begin
                  Sender.Value := UTF8Decode(aText);
             end
          else if TextUmwandelnOption = '2' then
             begin
                  Sender.Value := UTF8ToAnsi(aText);
             end
          else if TextUmwandelnOption = '3' then
             begin
                  Sender.Value := UTF8ToWinCP(aText);
             end
          else if TextUmwandelnOption = '4' then
             begin
                  Sender.Value := UTF8ToSys(aText);
             end
          else
              begin
                   Sender.Value := aText;
              end;
     end;
end;

procedure TDM.Text_von_DB_umwandeln(Sender: TField; var aText: string; DisplayText: BOOLEAN);
begin
  if Trim(Sender.AsString) <> '' then
     begin
          if TextUmwandelnOption = '1' then
             begin
                  aText := UTF8Encode(Sender.AsString);
             end
          else if TextUmwandelnOption = '2' then
             begin
                  aText := AnsiToUTF8(Sender.AsString);
             end
          else if TextUmwandelnOption = '3' then
             begin
                  aText := WinCPToUTF8(Sender.AsString);
             end
          else if TextUmwandelnOption = '4' then
             begin
                  aText := SysToUTF8(Sender.AsString);
             end
          else
              begin
                   aText := Sender.Value;
              end;
     end;

end;

function TDM.Text_von_Control_umwandeln(aText: string) : string;
begin
  if Trim(aText) <> '' then
     begin
          if TextUmwandelnOption = '1' then
             begin
                  Text_von_Control_umwandeln := UTF8Decode(aText);
             end
          else if TextUmwandelnOption = '2' then
             begin
                  Text_von_Control_umwandeln := UTF8ToAnsi(aText);
             end
          else if TextUmwandelnOption = '3' then
             begin
                  Text_von_Control_umwandeln := UTF8ToWinCP(aText);
             end
          else if TextUmwandelnOption = '4' then
             begin
                  Text_von_Control_umwandeln := UTF8ToSys(aText);
             end
          else
              begin
                   Text_von_Control_umwandeln := aText;
              end;
     end;
end;

function TDM.Text_nach_Control_umwandeln(aText: string) : string;
begin
  showmessage('#' + aText);
  if Trim(aText) <> '' then
     begin
          if TextUmwandelnOption = '1' then
             begin
                  Text_nach_Control_umwandeln := UTF8Encode(aText);
             end
          else if TextUmwandelnOption = '2' then
             begin
                  Text_nach_Control_umwandeln := AnsiToUTF8(aText);
             end
          else if TextUmwandelnOption = '3' then
             begin
                  Text_nach_Control_umwandeln := WinCPToUTF8(aText);
             end
          else if TextUmwandelnOption = '4' then
             begin
                  Text_nach_Control_umwandeln := SysToUTF8(aText);
             end
          else
              begin
                   Text_nach_Control_umwandeln := aText;
              end;
     end;

end;

end.

