unit unitfrmHauptform;

//{$ModeSwitch UnicodeStrings}

{$IFDEF FPC}
  {$mode objfpc}{$H+}
//  {$mode delphi}
//  {$mode objfpc}{$modeswitch unicodestrings}{$H+}   // Requires FPC 2.7.1+
//  {$mode delphiunicode}                             //   (See LLCL README.txt)
{$ENDIF}
{$IFDEF FPC_OBJFPC} {$DEFINE IS_FPC_OBJFPC_MODE} {$ENDIF}

interface

uses
  Classes, SysUtils, db, odbcconn, sqldb, unitDM, FileUtil, LazFileUtils, LazUTF8, RTTICtrls,
  LRDialogControls, Forms, Controls, Graphics, Dialogs,
  DBGrids, DbCtrls, StdCtrls, ActnList, Menus, ComCtrls, Buttons, ExtCtrls,
  EditBtn, INIFiles, Grids, ExtDlgs, types, DateUtils, IntfGraphics, //ShellCtrls,
  LCLType, LCLIntf, LCLVersion, strutils; //ValEdit, LR_View, , Variants, comobj;// shellapi;//, Calendar; //,Translations; für Spracheinstellung

type
     TMyGrid = Class(TCustomDBGrid);

  { TfrmHauptFormular }

  TfrmHauptFormular = class(TForm)
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem_SpalteAutoBreiteAendern: TMenuItem;
    MenuItem_Speichern: TMenuItem;
    MenuItem_Einlesen: TMenuItem;
    MenuItem_Standard: TMenuItem;
    PopupMenu_DBGrid: TPopupMenu;
    ImageList: TImageList;
    DBGrid_Position: TDBGrid;
    Label1: TLabel;
    StatusBar: TStatusBar;
    ToolBarPosition: TToolBar;
    ToolButtonPositionAendern: TToolButton;
    ToolButtonPositionLoeschen: TToolButton;
    ToolButtonPositionNeu: TToolButton;
    procedure DBGrid_PositionMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure DBGrid_PositionTitleClick(Column: TColumn);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure MenuItem_EinlesenClick(Sender: TObject);
    procedure MenuItem_SpalteAutoBreiteAendernClick(Sender: TObject);
    procedure MenuItem_SpeichernClick(Sender: TObject);
    procedure MenuItem_StandardClick(Sender: TObject);
    procedure StatusBarDblClick(Sender: TObject);
    procedure ToolButtonPositionAendernClick(Sender: TObject);
    procedure ToolButtonPositionLoeschenClick(Sender: TObject);
    procedure ToolButtonPositionNeuClick(Sender: TObject);
    procedure DBGridDrawColumnCell(Sender: TObject;
      const Rect: TRect; DataCol: Integer; Column: TColumn; State: TGridDrawState);
//  type

  private
    { private declarations }
public
    { public declarations }
   procedure PositionAendern(IDPosition : Int64);
   procedure AppException(Sender: TObject; E: Exception);
   function UmlauteErsetzen(Ursprung : string; InGrossBuchstabenUmwadeln : boolean) : string;

  end;

var
  frmHauptFormular: TfrmHauptFormular;
  INI : TINIFile;

  StartBeendet : boolean;

  Einstellungsdatei : String;
  ProgrammOrdner : String;
  DatenbankName : String;
  DatenbankExtension : String;
  Benutzername : String;
  DB_Driver : String;

  BenutzerID : Integer;   //Daten für den Login

  SizeBuffer: DWord;       // für GetUserName
  userNameBuffer: array[0..255] of char;
  i : Integer;

  Handbuch : string;  //Variable für die DAtei des Handbuchs. Es wird das entsprechende Programm gestartet
  FehlerDateiOperation : String; //DateiVerschieben.log

  // letztes Feld für die Sortierung von Grids
  DBGrid_Position_LetztesFeld : TColumn;

  DefaultGridWidth : Int64;
  MemoGridWidth : Int64;  //Einstellung für das Darstellen von Memofelder in einem Grid

  Entwicklung : string;

  UpdateZeitWert : String;  //dient für die Abfrage, ob sich die DB geändert hat
  DB_Update_Execute : boolean; //sollen die queries aufegfrischt werden
  IndexTimerPanel : Integer;
  FAppProps : TApplicationProperties;

//const

  function IniLaden(Section : String; Name : String) : string;
  function IniSpeichern(Section : String; Name : String; Wert : String; SectionLoeschen : Int64) : boolean;
  function GridSpeichern(Gridname : string; Formname : string) : boolean;
  function GridStandard(Gridname : string; Formname : string) : boolean;
  function GridEinlesen(Gridname : string; Formname : string) : boolean;
  function GridAutoSpalte(Gridname : string; Formname : string) : boolean;

implementation
uses unitfrmStart, unitfrmLogin, unitfrmPosition, unitfrmAuswahlKlein;

{$R *.lfm}

{ TfrmHauptFormular }

function IniSpeichern(Section : String; Name : String; Wert : String; SectionLoeschen : Int64) : boolean;
begin
    // beim 1. Wert i =0 wird die ganze Section gelöscht, wegen alter werte
  If FileExistsUTF8(Einstellungsdatei) Then
     Begin
          INI := TINIFile.Create(Einstellungsdatei);
          if SectionLoeschen = 0 then    //das funktioniert noch nicht. ist auch die falsche funktion. diese darf nur 1x aufgerufen werden
             begin
                  if INI.SectionExists(Section) = True then
                     Begin
                       //INI.WriteString(Section, '', '');
                          INI.EraseSection(Section) ;
                     end;
             end;
          INI := TINIFile.Create(Einstellungsdatei);
          if Wert <> '' then
            begin
                 INI.WriteString(Section, Name, Wert);
            end
          else
              begin
                   INI.DeleteKey(Section, Name);
              end;
     end
  Else
      MessageDlg('Einstellungsdatei', 'Einstellungsdatei wurde nicht gefunden. Es werden Standardeinstellungen vorgenommen.', mtInformation, [mbOk],0);
      //LadeIniDefault;

  INI.Free;
end;

function IniLaden(Section : String; Name : String) : string;
begin
     If FileExistsUTF8(Einstellungsdatei) Then
        Begin
             INI := TINIFile.Create(Einstellungsdatei);
             If INI.ReadString(Section,Name,'') <> '' then
                IniLaden := INI.ReadString(Section,Name,'')
             Else
               IniLaden := '';
                 //DatenbankOrdner := ExtractFilePath(Application.ExeName);
                 //IniLaden := true;
        end
     Else
         MessageDlg('Einstellungsdatei', 'Einstellungsdatei wurde nicht gefunden. Es werden Standardeinstellungen vorgenommen.', mtInformation, [mbOk],0);
         //LadeIniDefault;
         //IniLaden := false;

     INI.Free;

end;

function GridEinlesen(Gridname : string; Formname : string) : boolean;
var
    Grid : TDBGrid;
    Form : TForm;
    TagNrStr : string;
    GridBreiteZellenGesamt : Int64;
    AutoNr : Int64;
begin
  Form := TForm(Application.FindComponent(Formname));
   if Assigned(Form) then
   begin
        GridBreiteZellenGesamt := 0;
        Grid := TDBGrid(Form.FindComponent(Gridname));
        if Assigned(Grid) then
           begin
                //showmessage(IntToStr(Grid.Columns.Count));
                if Grid.Tag = 0 then
                  begin
                       TagNrStr := '';
                  end
                else
                    begin
                         TagNrStr := IntToStr(Grid.Tag);
                    end;
              if IniLaden (Grid.Name + TagNrStr,'AutoNr') <> '' then
                begin
                     AutoNr:=StrToInt(IniLaden (Grid.Name + TagNrStr,'AutoNr'));
                end
              else
                  begin
                    AutoNr:=-1;
                  end;
             for i:=0 to Grid.Columns.Count-1 do
                 if IniLaden (Grid.Name + TagNrStr,IntToStr(i)) <> '' then
                    begin
                      if i = AutoNr then
                         begin
                              Grid.Columns.Items[i].Width:=0;
                         end
                      else
                         begin
                              Grid.Columns.Items[i].Width:=StrToInt(IniLaden (Grid.Name + TagNrStr,IntToStr(i)));
                              GridBreiteZellenGesamt := GridBreiteZellenGesamt + StrToInt(IniLaden (Grid.Name + TagNrStr,IntToStr(i)));
                         end;
                    end
                 Else
                    begin
                      Grid.Columns.Items[i].Width:=0;
                    end;
                 if AutoNr <> -1 then
                    begin
                      //showmessage(IntToStr(AutoNr) + '-' + IntToStr(Grid.Width) + '-' + IntToStr(GridBreiteZellenGesamt));
                       Grid.Columns.Items[AutoNr].Width:= Grid.Width - GridBreiteZellenGesamt - 35;
                    end;
                frmStart.lstNachricht.Items.Append(Grid.Name + ' laden:Werte sind eingelesen worden.') ;
           end
        else
            begin
              frmStart.lstNachricht.Items.Append(Gridname + ' nicht gefunden.') ;
            end;
   end
   else
       begin
         frmStart.lstNachricht.Items.Append(Formname + ' nicht gefunden.') ;
       end;
end;

function GridSpeichern(GridName : string; Formname : string) : boolean;
var
    Grid : TDBGrid;
    Form : TForm;
    TagNrStr : string;
begin
  Form := TForm(Application.FindComponent(Formname));
   if Assigned(Form) then
   begin
        Grid := TDBGrid(Form.FindComponent(Gridname));
        if Assigned(Grid) then
           begin
           if Grid.Tag = 0 then
             begin
                  TagNrStr := '';
             end
           else
               begin
                    TagNrStr := IntToStr(Grid.Tag);
               end;

             for i:=0 to Grid.Columns.Count-1 do
                if Grid.Columns.Items[i].Width = 0 then
                   begin
                        IniSpeichern (Grid.Name + TagNrStr,IntToStr(i),'',i);
                   end
                else
                    begin
                         IniSpeichern (Grid.Name + TagNrStr,IntToStr(i),IntToStr(Grid.Columns.Items[i].Width),i);
                    end;
                frmStart.lstNachricht.Items.Append(Grid.Name + ' speichern:Einstellungen sind gespeichert worden.') ;
           end
        else
            begin
              frmStart.lstNachricht.Items.Append(Gridname + ' nicht gefunden.') ;
            end;
   end
   else
       begin
         frmStart.lstNachricht.Items.Append(Formname + ' nicht gefunden.') ;
       end;
end;

function GridStandard(Gridname : string; Formname : string) : boolean;
var
  Grid : TDBGrid;
  Form : TForm;
begin
    Form := TForm(Application.FindComponent(Formname));
     if Assigned(Form) then
     begin
          Grid := TDBGrid(Form.FindComponent(Gridname));
          if Assigned(Grid) then
             begin
                  for i:=0 to Grid.Columns.Count-1 do
                  Grid.Columns.Items[i].Width:=DefaultGridWidth;
                  frmStart.lstNachricht.Items.Append(Grid.Name + ' laden:Standardwerte sind eingelesen worden.') ;
             end
          else
              begin
                frmStart.lstNachricht.Items.Append(Gridname + ' nicht gefunden.') ;
              end;
     end
     else
         begin
           frmStart.lstNachricht.Items.Append(Formname + ' nicht gefunden.') ;
         end;
end;

function GridAutoSpalte(Gridname : string; Formname : string) : boolean;
var
    Grid : TDBGrid;
    Form : TForm;
    TagNrStr : string;
    AutoNr : Int64;
begin
  Form := TForm(Application.FindComponent(Formname));
   if Assigned(Form) then
   begin
        Grid := TDBGrid(Form.FindComponent(Gridname));
        if Assigned(Grid) then
           begin
                if Grid.Tag = 0 then
                  begin
                       TagNrStr := '';
                  end
                else
                    begin
                         TagNrStr := IntToStr(Grid.Tag);
                    end;
              if IniLaden (Grid.Name + TagNrStr,'AutoNr') <> '' then
                begin
                     AutoNr:=StrToInt(IniLaden (Grid.Name + TagNrStr,'AutoNr'));
                end
              else
                  begin
                    AutoNr:=-1;
                  end;
                  frmAuswahlKlein.ComboBox_Auswahl.Clear;
             for i:=0 to Grid.Columns.Count-1 do
                 begin
                   frmAuswahlKlein.ComboBox_Auswahl.Items.Add(Grid.Columns.Items[i].FieldName);
                 end;

             frmAuswahlKlein.ComboBox_Auswahl.ReadOnly:=true;
             frmAuswahlKlein.ComboBox_Auswahl.ItemIndex:=AutoNr;
             frmAuswahlKlein.ShowModal;
             frmAuswahlKlein.ComboBox_Auswahl.ReadOnly:=false;

             if frmAuswahlKlein.Antwort = true then
                begin
                  if frmAuswahlKlein.ComboBox_Auswahl.ItemIndex <> -1 then
                     begin
                          IniSpeichern(Grid.Name + TagNrStr,'AutoNr', IntToStr(frmAuswahlKlein.ComboBox_Auswahl.ItemIndex),1);
                     end
                  else
                      begin
                        IniSpeichern (Grid.Name + TagNrStr,'AutoNr','', 1);
                      end;
                end
             else
                 begin
                   IniSpeichern (Grid.Name + TagNrStr,'AutoNr','',1);
                 end;

           frmStart.lstNachricht.Items.Append(Grid.Name + ' Autospalte:Wert gespeichert.') ;
           end
        else
            begin
              frmStart.lstNachricht.Items.Append(Gridname + ' nicht gefunden.') ;
            end;
   end
  else
      begin
         frmStart.lstNachricht.Items.Append(Formname + ' nicht gefunden.') ;
      end;
end;

procedure TfrmHauptFormular.DBGrid_PositionTitleClick(Column: TColumn);
var
  ASC_IndexName,DESC_IndexName:string;
begin
//  showmessage(IntToStr(unitDM.DM.SQLQueryPosition.IndexDefs.Count));
  // wenn 0 dann standard speichern
  ASC_IndexName:='ASC_'+Column.FieldName;
  DESC_IndexName:='DESC_'+Column.FieldName;
  //indexes can't sort binary types such as ftmemo, ftblob
  if (Column.Field.DataType in [ftblob,ftmemo,ftwidememo]) then exit;
  //check if an Ascending index already exists for this column, if not create one
  if unitDM.DM.SQLQueryPosition.IndexDefs.IndexOf(ASC_IndexName) = -1 then unitDM.DM.SQLQueryPosition.AddIndex(ASC_IndexName,column.FieldName,[]);
  //check if a Descending index already exists for this column, if not create one
  if unitDM.DM.SQLQueryPosition.IndexDefs.IndexOf(DESC_IndexName) = -1 then unitDM.DM.SQLQueryPosition.AddIndex(DESC_IndexName,column.FieldName,[ixDescending]);
  //ensure index defs are up to date
  unitDM.DM.SQLQueryPosition.IndexDefs.Updated:=false; {<<<--This line is critical, IndexDefs.Update will not
    update if already true, which will happen on the first column sorted.}
  unitDM.DM.SQLQueryPosition.IndexDefs.Update;
  //use the column tag to toggle ASC/DESC
  column.tag :=  not column.tag;
  if boolean(column.tag) then
  begin
    Column.Title.ImageIndex:=15;
    unitDM.DM.SQLQueryPosition.IndexName:=ASC_IndexName;
  end else
  begin
    Column.Title.ImageIndex:=16;
    unitDM.DM.SQLQueryPosition.IndexName:=DESC_IndexName;
  end;
  //Remove the sort arrow from the last column
  if (DBGrid_Position_LetztesFeld <> nil) and (DBGrid_Position_LetztesFeld <> Column) then DBGrid_Position_LetztesFeld.Title.ImageIndex:=-1;
  DBGrid_Position_LetztesFeld:=column;
end;

procedure TfrmHauptFormular.FormCloseQuery(Sender: TObject;
  var CanClose: boolean);
var
i : integer;
closeSQL : TObject;
begin
  for i := 0 to ComponentCount - 1 do
    begin
         closeSQL := Components[i];
         if closeSQL is TSQLQuery then (closeSQL As TSQLQuery).Close;
    end;

  unitDM.DM.ODBCConnection.Connected:= false;
  CanClose := True;
end;

procedure TfrmHauptFormular.FormCreate(Sender: TObject);
begin
  FAppProps := TApplicationProperties.Create(Self);
  FAppProps.OnException := @AppException;
  FAppProps.CaptureExceptions := True;
  StartBeendet := false;
//  TranslateUnitResourceStrings('LCLStrConsts', ExtractFilePath(Application.ExeName) + '\languages\lclstrconsts.de.po');
end;

procedure TfrmHauptFormular.DBGridDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn; State: TGridDrawState);

  var
    s: string;
    FolgeString : string;
begin
    with (Sender as TDBGrid) do begin
      if Column.Field.IsBlob then
         begin
             if length(Column.Field.AsString) > MemoGridWidth then
                begin
                    FolgeString := '...';
                end;
             Canvas.FillRect(Rect);
             s := copy(Column.Field.AsString, 1, MemoGridWidth);
             Canvas.TextOut(Rect.Left+2, Rect.Top+2, s + FolgeString);
          end
      else
          begin
               DefaultDrawColumnCell(Rect, DataCol, Column, State);
          end;
    end;

end;

procedure TfrmHauptFormular.DBGrid_PositionMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
  var
    row : integer;
    col : integer;
    rec : integer;
  begin
    //inherited;

    TDBGrid(Sender).ShowHint:=true;

    // http://forum.lazarus.freepascal.org/index.php?topic=13439.0
    TDBGrid(Sender).MouseToCell(X, Y, col, row);

    if dgTitles in TDBGrid(Sender).Options then
      Dec(row);
    if dgIndicator in TDBGrid(Sender).Options then
      Dec(col);

    if TMyGrid(TDBGrid(Sender)).DataLink.Active and
       (row >= 0) and (col >= 0) then begin
      rec := TMyGrid(TDBGrid(Sender)).DataLink.ActiveRecord;
      try
        TMyGrid(TDBGrid(Sender)).DataLink.ActiveRecord := row;
        if TDBGrid(Sender).Columns[col].Field.AsString <> '' then
          begin
            TDBGrid(Sender).Hint := TDBGrid(Sender).Columns[col].FieldName + ': '+ TDBGrid(Sender).Columns[col].Field.AsString;
          end
        else
            begin
              TDBGrid(Sender).Hint := '';
            end;
        Application.ActivateHint(Mouse.CursorPos);
      finally
        TMyGrid(TDBGrid(Sender)).DataLink.ActiveRecord:= rec;
        //TDBGrid(Sender).Hint := 'keine Daten zum Anzeigen';
      end;
    end;
  end;

procedure TfrmHauptFormular.FormShow(Sender: TObject);
var
//   i : integer;
   OSVariable : string;
   StartZeit : cardinal;
   temp : string;

begin
  StartZeit:=GetTickCount;
  frmStart.Icon := Application.Icon ;
  SizeBuffer := 256;

  Einstellungsdatei := ExtractFilePath(Application.ExeName) + 'EINSTELLUNGEN.INI';

  if FileExistsUTF8(Einstellungsdatei) = false then
     begin
          MessageDlg('Einstellungsdatei nicht gefunden', 'Die Einstellungsdatei "EINSTELLUNGEN.INI" existiert nicht in dem Programmverzeichnis. Das Programm wird beendet.', mtWarning, [mbOk],0);
          Application.Terminate;
          exit;
     end;

  OSVariable:=IniLaden ('APPLICATION','OS_VARIABLE');
  Benutzername := SysUtils.GetEnvironmentVariable(OSVariable);

  unitDM.TextUmwandelnOption:=IniLaden ('DATABASE','TEXT_UMWANDELN_OPTION');

  Entwicklung:=IniLaden ('APPLICATION','ENTWICKLUNG_TEST');
  if Entwicklung = '' then Entwicklung := '1';

  DatenbankExtension:=IniLaden ('GLOBAL','DB_EXTENSION');
  if DatenbankExtension = '' then DatenbankExtension:='.mdb';

  DB_Driver := IniLaden ('GLOBAL','DB_DRIVER');
  if DB_Driver = '' then DB_Driver := 'Microsoft Access Driver (*.mdb)';

  if IniLaden ('GLOBAL','DefaultGridWidth') <> '' then
     begin
          DefaultGridWidth := StrToInt(IniLaden ('GLOBAL','DefaultGridWidth'));
     end
  else
      begin
           DefaultGridWidth := 0;
      end;
  if IniLaden ('GLOBAL','MemoGridWidth') <> '' then
     begin
          MemoGridWidth := StrToInt(IniLaden ('GLOBAL','MemoGridWidth'));
     end
  else
      begin
           MemoGridWidth := 0;
      end;

  DatenbankName := StringReplace(IniLaden ('GLOBAL','DBQ'),'[APPLICATION]',ExtractFilePath(Application.ExeName),[rfReplaceAll]);

  FehlerDateiOperation := IniLaden ('GLOBAL','Fehlerdateiname'); //Dateinamen für die Fehlerdatei bei verschieben, kopieren der Dateien
  if FehlerDateiOperation = '' then
     begin
          FehlerDateiOperation := ExtractFilePath(Application.ExeName) + 'DATEIOPERATION.ERR';
     end
  else
      begin
         FehlerDateiOperation := ExtractFilePath(Application.ExeName) + FehlerDateiOperation;
      end;

  if DefaultGridWidth = 0 then DefaultGridWidth := 100;
  if MemoGridWidth = 0 then MemoGridWidth := 25;
  if FileExists(DatenbankName) = false then
     begin
          DatenbankName := '';
     end;
  DB_Update_Execute := true;

  frmStart.ShowOnTop;
  frmStart.Caption:= 'Programmstarter';
  frmStart.lstNachricht.Items.Append('Programm wird gestartet. Bitte warte...') ;
//  frmStart.lstNachricht.Items.Append('Progammversion: ' + Programmversion()) ;
  frmStart.Refresh;
  if DatenbankName = '' then
     begin
       frmStart.lstNachricht.Items.Append('Datenbank nicht gefunden. Auswahl wird gestartet.')
     end
  else
      begin
        frmStart.lstNachricht.Items.Append('Datenbank:' + DatenbankName)
      end;
  frmStart.Refresh;

  frmStart.lstNachricht.Items.Append('Benutzer:' + Benutzername) ;
  frmStart.Refresh;

  if DatenbankName = '' then
     begin
          frmLogin.txtBenutzer.Text:=Benutzername;
          frmLogin.FileListBox_DB.Directory := ExtractFilePath(Application.ExeName);
          frmLogin.FileListBox_DB.Mask := '*.mdb';
          frmLogin.FileListBox_DB.Items.Text; //   .ItemIndex :=0; //  .Selected[1];
          frmLogin.ToolButtonLoginOk.Enabled:=False;
  //  showmessage(frmLogin.FileListBox_DB.FileName);
//      frmLogin.lbInfo.Caption := 'Programmversion:' + Programmversion();
      frmLogin.showmodal;

      If frmLogin.Antwort = False then
         begin
              Application.Terminate;
              exit;
         end
      else
         begin
           DatenbankName:=StringReplace(frmLogin.FileListBox_DB.FileName,'\\',DirectorySeparator,[rfReplaceAll]);
         end;
      end;

  frmStart.lstNachricht.Items.Append('Datenbank wird geladen.') ;
  frmStart.Refresh;

    frmStart.lstNachricht.Items.Append('Datenbanktreiber:' + DB_Driver) ;
    frmStart.Refresh;

     unitDM.DM.ODBCConnection.Driver:= DB_Driver;

    frmStart.lstNachricht.Items.Append('Datenbank:' + DatenbankName) ;
    frmStart.Refresh;

  unitDM.DM.ODBCConnection.Params.Add('DBQ=' + DatenbankName);
  unitDM.DM.ODBCConnection.Params.Add('AUTOCOMMIT=1');
  unitDM.DM.ODBCConnection.Params.Add('Locale Identifier=1031');
  unitDM.DM.ODBCConnection.Params.Add('CHARSET=UTF8');

   frmStart.lstNachricht.Items.Append('Datenbank verbinden.') ;
   frmStart.Refresh;

   unitDM.DM.ODBCConnection.Connected:= True;
   unitDM.DM.ODBCConnection.KeepConnection := True;

   unitDM.DM.SQLTransaction.DataBase := unitDM.DM.ODBCConnection;
   unitDM.DM.SQLTransaction.Action := caCommit;
   unitDM.DM.SQLTransaction.Active := false; //not applied to ms access(false) bei true kommt fehler das die transaktion schon aktiv ist
   unitDM.DM.SQLTransaction.StartTransaction;

   frmStart.lstNachricht.Items.Append('Grundeinstellung der SQL-Controls') ;
   frmStart.Refresh;

   unitDM.DM.SQLQueryAnbinden();

          frmStart.lstNachricht.Items.Append('Laden der SQL-Controls') ;
          frmStart.Refresh;

          unitDM.DM.SQLQuerySystem.SQL.Text := 'SELECT * FROM tbSystem';
          unitDM.DM.SQLQuerySystem.Open;
          unitDM.DM.DatasourceSystem.DataSet := unitDM.DM.SQLQuerySystem;

          unitDM.DM.SQLQuerySystem.Filter := 'Feld=''' + unitDM.DM.SQLQueryPosition.Name + '''';
          if unitDM.DM.SQLQuerySystem.IsEmpty <> true then
             begin
                  unitDM.DM.SQLQueryPosition.SQL.Text := unitDM.DM.SQLQuerySystem.FieldByName('Wert').AsString;
                  unitDM.DM.SQLQueryPosition.Open;
                  unitDM.DM.DatasourcePosition.DataSet := unitDM.DM.SQLQueryPosition;
                  DBGrid_Position.DataSource := unitDM.DM.DatasourcePosition;
                  unitDM.DM.SQLQueryPosition.Last;
                  unitDM.DM.SQLQueryPosition.First;
             end;

     frmStart.lstNachricht.Items.Append('Layout wird eingelesen.') ;
     frmStart.Refresh;

     DBGrid_Position.DataSource.DataSet.First;

     GridEinlesen (DBGrid_Position.Name, GetParentForm(DBGrid_Position).Name);

     StatusBar.Panels.Items[0].Text := 'Benutzer:' + Benutzername;

     frmStart.Close;
     frmStart.lstNachricht.Items.Append('Programmstart beendet. Startzeit:' + IntToStr(GetTickCount-StartZeit) + ' ms');
     StatusBar.Panels.Items[1].Text := 'Programmstart beendet. Startzeit:' + IntToStr(GetTickCount-StartZeit) + ' ms';

     StartBeendet := true;

end;

procedure TfrmHauptFormular.MenuItem_EinlesenClick(Sender: TObject);
begin
    GridEinlesen (PopupMenu_DBGrid.Items[0].Caption, PopupMenu_DBGrid.Items[1].Caption);
end;

procedure TfrmHauptFormular.MenuItem_SpalteAutoBreiteAendernClick(
  Sender: TObject);
begin
  GridAutoSpalte (PopupMenu_DBGrid.Items[0].Caption, PopupMenu_DBGrid.Items[1].Caption);
end;

procedure TfrmHauptFormular.MenuItem_SpeichernClick(Sender: TObject);
begin
    GridSpeichern (PopupMenu_DBGrid.Items[0].Caption, PopupMenu_DBGrid.Items[1].Caption);
end;

procedure TfrmHauptFormular.MenuItem_StandardClick(Sender: TObject);
begin
    GridStandard (PopupMenu_DBGrid.Items[0].Caption, PopupMenu_DBGrid.Items[1].Caption);
end;

procedure TfrmHauptFormular.StatusBarDblClick(Sender: TObject);
begin
  frmStart.showmodal;
end;

procedure TfrmHauptFormular.ToolButtonPositionAendernClick(Sender: TObject);
begin
     PositionAendern (unitDM.DM.SQLQueryPosition.FieldByName('ID').AsInteger);
end;

procedure TfrmHauptFormular.ToolButtonPositionLoeschenClick(Sender: TObject);
begin
         if QuestionDlg('Position löschen', 'Wollen Sie die Position ' + Trim(unitDM.DM.SQLQueryPosition.FieldByName('Position').AsString) + ' wirklich löschen? Die Aktion kann nicht rückgängig gemacht werden.'+ #13 + #13, mtWarning, [mrYes, 'Ja', mrNo, 'Nein'], 0) = mrYes then
           begin
                unitDM.DM.SQLQueryPosition.Delete;
                unitDM.DM.SQLQueryPosition.ApplyUpdates;
                unitDM.DM.SQLQueryPosition.Refresh;
                unitDM.DM.SQLQueryPosition.First;

                frmStart.lstNachricht.Items.Append('Position:Position wurde erfolgreich löschen.') ;
                StatusBar.Panels.Items[1].Text := 'Position:Position wurde erfolgreich löschen.';
           end;
end;

procedure TfrmHauptFormular.ToolButtonPositionNeuClick(Sender: TObject);
begin
  PositionAendern (0);
//  RefreshSQLQuery;
end;

procedure TfrmHauptFormular.PositionAendern(IDPosition : Int64);
var
   Position_Rec : integer;
   Kategorie : String;
begin

  DB_Update_Execute := false; //updates der queries stoppen

       if IDPosition <> 0 then
           begin
             frmPosition.TechnPlatz_Edit.Text:=unitDM.DM.SQLQueryPosition.FieldByName('TechnischerPlatz').AsString;//   .AsString;
             frmPosition.Position_Edit.Text := unitDM.DM.SQLQueryPosition.FieldByName('Position').AsString;
             frmPosition.Bezeichnung_Edit.Text := unitDM.DM.SQLQueryPosition.FieldByName('Bezeichnung').AsString;
           end
        else
            begin
              frmPosition.Position_Edit.Text:='';
              frmPosition.Bezeichnung_Edit.Text:='';
              frmPosition.TechnPlatz_Edit.Text:='';
            end;
        frmPosition.ShowModal;

    If frmPosition.Antwort=True Then
       begin
         try
        //   begin
            if IDPosition <> 0 then
               begin
                    Position_Rec := unitDM.DM.SQLQueryPosition.RecNo;
                    unitDM.DM.SQLQueryPosition.Edit;
               end
            else
               begin
                    Position_Rec := 0;
                    unitDM.DM.SQLQueryPosition.Append;
               end;

            unitDM.DM.SQLQueryPosition.FieldByName('Position').Value := frmPosition.Position_Edit.Text;
            unitDM.DM.SQLQueryPosition.FieldByName('Bezeichnung').Value := frmPosition.Bezeichnung_Edit.Text;
            unitDM.DM.SQLQueryPosition.FieldByName('TechnischerPlatz').Value := unitDM.DM.Text_von_Control_umwandeln(frmPosition.TechnPlatz_Edit.Text);

            unitDM.DM.SQLQueryPosition.FieldByName('SpeicherDatum').Value:=FormatDateTime('dd.mm.yyyy',Now);
            unitDM.DM.SQLQueryPosition.FieldByName('SpeicherUhrzeit').Value:=FormatDateTime('hh:mm:ss',Now);
            unitDM.DM.SQLQueryPosition.FieldByName('Benutzer').Value:=Benutzername;
            unitDM.DM.SQLQueryPosition.Post;
            unitDM.DM.SQLQueryPosition.ApplyUpdates;
            unitDM.DM.SQLQueryPosition.Refresh;
         except
           on E : Exception do
              ShowMessage('Fehler in:' + E.ClassName + ' , Fehlermeldung: ' + E.Message);
           end;
            frmStart.lstNachricht.Items.Append('Position:Daten sind gespeichert worden.') ;
            StatusBar.Panels.Items[1].Text := 'Position:Daten sind gespeichert worden.';

           end;

    DB_Update_Execute := true; //updates der queries starten

end;

procedure TfrmHauptFormular.AppException(Sender: TObject; E: Exception);
var
  FileVar : Textfile;
  FehlerDateiName : String;
begin
  showmessage('Fehler:' + e.Message + '; Objekt:' + Sender.ClassName);
  FehlerDateiName := ExtractFilePath(Application.ExeName) + 'error.log';
  AssignFile(FileVar, FehlerDateiName); // You do not have to put .txt but this is just for now
  {$I+} //use exceptions
  try
     if FileExistsUTF8(FehlerDateiName) = true then
        begin
             Append(FileVar);
        end
     else
         begin
              Rewrite(FileVar);  // creating the file
         end;
         Writeln(FileVar,'###---begin---###');
         Writeln(FileVar,'Benutzer:' + Benutzername);
         Writeln(FileVar,'Datum:' + FormatDateTime('dd.mm.yyyy',Now));
         Writeln(FileVar,'Uhrzeit:' + FormatDateTime('hh:mm:ss',Now));
//         Writeln(FileVar,'Programmversion: ' + Programmversion());
         Writeln(FileVar,'Anwendung kompiliert am:' + {$I %DATE%}  + ' um ' + {$I %TIME%});
         Writeln(FileVar,'Programmplatform: ' + {$I %FPCTARGETOS%});
         Writeln(FileVar,'Compiler: Freepascal ' + {$I %FPCVERSION%});
         Writeln(FileVar,'Entwicklungsumgebung: Lazarus ' + lcl_version);
         Writeln(FileVar,'Fehler:' + e.Message);
         Writeln(FileVar,'Objekt:' + Sender.ClassName);
         Writeln(FileVar,'Unitname:' + Sender.UnitName);
         Writeln(FileVar,'###---end---###');
         CloseFile(FileVar);
  except
        on E: EInOutError do
           begin
                Writeln('Dateihandling Fehler. Details: '+E.ClassName+'/'+E.Message);
           end;
  end;

  // here you can create your own dialog. .... from E you can get E.Message,
 // also, you can use DumpExceptionBackTrace to dump more info etc etc ...
end;

function TfrmHauptFormular.UmlauteErsetzen(Ursprung : string; InGrossBuchstabenUmwadeln : boolean) : string;
var
    NeuerText : string;
begin
  NeuerText := Ursprung;
  NeuerText := StringReplace(NeuerText,'Ö','Oe',[rfReplaceAll]);
  NeuerText := StringReplace(NeuerText,'ö','oe',[rfReplaceAll]);
  NeuerText := StringReplace(NeuerText,'Ä','Ae',[rfReplaceAll]);
  NeuerText := StringReplace(NeuerText,'ä','ae',[rfReplaceAll]);
  NeuerText := StringReplace(NeuerText,'Ü','Ue',[rfReplaceAll]);
  NeuerText := StringReplace(NeuerText,'ü','ue',[rfReplaceAll]);
  NeuerText := StringReplace(NeuerText,'ß','sz',[rfReplaceAll]);

  if InGrossBuchstabenUmwadeln = true then NeuerText:= UpperCase(NeuerText);

  UmlauteErsetzen := NeuerText;
end;


end.

